(   Title:  Enhanced error display for xtester
     File:  xtester-errors.fs
   Author:  David N. Williams
  License:  Public Domain
  Version:  1.3.1
  Revised:  January 31, 2011

The date above may reflect cosmetic changes not logged here.

Version 1.3.1
31Jan11 * Removed "Unexpected" from ?.XT-ERRORS.
        * Added XT-FANCY-A. and XT-ERROR3.

Version 1.3.0
17Jan11 * Extracted from ttester-xf-test.fs 1.2.1.
)

VARIABLE XT-#ERRORS    0 XT-#ERRORS !
: XT-ERROR1  ( c-addr u -- )
\ Display an error message followed by the line that had the
\ error.
  red-text 1 XT-#ERRORS +! XT-ERROR-DEFAULT normal-text ;
\ ' XT-ERROR1 XT-ERROR-XT !

\ display results and goals
: xt-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup >r @ dup
  IF   1- r> cell+ swap cells over +  \ display deepest first
       DO i @ . -1 cells +LOOP
  ELSE r> 2drop ." none" THEN cr normal-text ;

: XT-ERROR2  ( c-addr u -- )
  XT-ERROR1
  XT-RESULTS s"   xresults: " xt-a.
  XT-GOALS   s"     xgoals: " xt-a. ;
\ ' XT-ERROR2 XT-ERROR-XT !

\ fancy results and goals display
: xt-fancy-a.  ( 'array c-addr u -- )
  blue-text type
  ( 'array) dup @ swap cell+ swap ?dup
  IF   ( n) 1- 0 swap  \ display deepest first
       DO ( 'elem) i cells over + @
          i XT-ERROR-INDEX @ =
          IF red-text . blue-text ELSE . THEN
       -1 +LOOP
  ELSE ." none" THEN drop cr normal-text ;

: XT-ERROR3  ( c-addr u -- )
  XT-ERROR1
  XT-RESULTS s"   xresults: " xt-fancy-a.
  XT-GOALS   s"     xgoals: " xt-fancy-a. ;
' XT-ERROR3 XT-ERROR-XT !

: ?.xt-errors  ( -- )
  VERBOSE @ IF
  blue-text ." XT-ERRORS: " normal-text XT-#ERRORS @ . THEN ;
